## dump1090-10.2.tar.gz

=== Makefile ===
PROGNAME=dump1090

DUMP1090_VERSION ?= unknown

CFLAGS ?= -O3 -g
DUMP1090_CFLAGS := -std=c11 -fno-common -Wall -Wmissing-declarations -Werror -Wformat-signedness -W
DUMP1090_CPPFLAGS := -I. -D_POSIX_C_SOURCE=200112L -DMODES_DUMP1090_VERSION=\"$(DUMP1090_VERSION)\" -DMODES_DUMP1090_VARIANT=\"dump1090-fa\"

LIBS = -lpthread -lm
SDR_OBJ = cpu.o sdr.o fifo.o sdr_ifile.o dsp/helpers/tables.o

# Try to autodetect available libraries via pkg-config if no explicit setting was used
PKGCONFIG=$(shell pkg-config --version >/dev/null 2>&1 && echo "yes" || echo "no")
ifeq ($(PKGCONFIG), yes)
  ifndef RTLSDR
    ifdef RTLSDR_PREFIX
      RTLSDR := yes
    else
      RTLSDR := $(shell pkg-config --exists librtlsdr && echo "yes" || echo "no")
    endif
  endif

  ifndef BLADERF
    BLADERF := $(shell pkg-config --exists libbladeRF && echo "yes" || echo "no")
  endif

  ifndef HACKRF
    HACKRF := $(shell pkg-config --exists libhackrf && echo "yes" || echo "no")
  endif

  ifndef LIMESDR
    LIMESDR := $(shell pkg-config --exists LimeSuite && echo "yes" || echo "no")
  endif

  ifndef SOAPYSDR
    SOAPYSDR := $(shell pkg-config --exists SoapySDR && echo "yes" || echo "no")
  endif
else
  # pkg-config not available. Only use explicitly enabled libraries.
  RTLSDR ?= no
  BLADERF ?= no
  HACKRF ?= no
  LIMESDR ?= no
  SOAPYSDR ?= no
endif

BUILD_UNAME := $(shell uname)
BUILD_ARCH := $(shell uname -m)

UNAME ?= $(BUILD_UNAME)
ARCH ?= $(BUILD_ARCH)

ifeq ($(UNAME), Linux)
  DUMP1090_CPPFLAGS += -D_DEFAULT_SOURCE
  LIBS += -lrt
  LIBS_USB += -lusb-1.0
  LIBS_CURSES := -lncurses
  CPUFEATURES ?= yes
endif

ifeq ($(UNAME), Darwin)
  ifneq ($(shell sw_vers -productVersion | egrep '^10\.([0-9]|1[01])\.'),) # Mac OS X ver <= 10.11
    DUMP1090_CPPFLAGS += -DMISSING_GETTIME
    COMPAT += compat/clock_gettime/clock_gettime.o
  endif
  DUMP1090_CPPFLAGS += -DMISSING_NANOSLEEP
  COMPAT += compat/clock_nanosleep/clock_nanosleep.o
  ifeq ($(PKGCONFIG), yes)
    LIBS_SDR += $(shell pkg-config --libs-only-L libusb-1.0)
  endif
  LIBS_USB += -lusb-1.0
  LIBS_CURSES := -lncurses
  # cpufeatures reportedly does not work (yet) on darwin arm64
  ifneq ($(ARCH),arm64)
    CPUFEATURES ?= yes
  endif
endif

ifeq ($(UNAME), OpenBSD)
  DUMP1090_CPPFLAGS += -DMISSING_NANOSLEEP
  COMPAT += compat/clock_nanosleep/clock_nanosleep.o
  LIBS_USB += -lusb-1.0
  LIBS_CURSES := -lncurses
endif

ifeq ($(UNAME), FreeBSD)
  DUMP1090_CPPFLAGS += -D_DEFAULT_SOURCE
  LIBS += -lrt
  LIBS_USB += -lusb
  LIBS_CURSES := -lncurses
endif

ifeq ($(UNAME), NetBSD)
  DUMP1090_CPPFLAGS += -D_DEFAULT_SOURCE
  LIBS += -lrt
  LIBS_USB += -lusb-1.0
  LIBS_CURSES := -lcurses
endif

CPUFEATURES ?= no

ifeq ($(CPUFEATURES),yes)
  include Makefile.cpufeatures
  DUMP1090_CPPFLAGS += -DENABLE_CPUFEATURES -Icpu_features/include
endif

RTLSDR ?= yes
BLADERF ?= yes

ifeq ($(RTLSDR), yes)
  SDR_OBJ += sdr_rtlsdr.o
  DUMP1090_CPPFLAGS += -DENABLE_RTLSDR

  ifdef RTLSDR_PREFIX
    DUMP1090_CPPFLAGS += -I$(RTLSDR_PREFIX)/include
    ifeq ($(STATIC), yes)
      LIBS_SDR += -L$(RTLSDR_PREFIX)/lib -Wl,-Bstatic -lrtlsdr -Wl,-Bdynamic $(LIBS_USB)
    else
      LIBS_SDR += -L$(RTLSDR_PREFIX)/lib -lrtlsdr $(LIBS_USB)
    endif
  else
    # some packaged .pc files are massively broken, try to handle it

    # FreeBSD's librtlsdr.pc includes -std=gnu89 in cflags
    # some linux librtlsdr packages return a bare -I/ with no path in --cflags
    RTLSDR_CFLAGS := $(shell pkg-config --cflags librtlsdr)
    RTLSDR_CFLAGS := $(filter-out -std=%,$(RTLSDR_CFLAGS))
    RTLSDR_CFLAGS := $(filter-out -I/,$(RTLSDR_CFLAGS))
    DUMP1090_CFLAGS += $(RTLSDR_CFLAGS)

    # some linux librtlsdr packages return a bare -L with no path in --libs
    # which horribly confuses things because it eats the next option on the command line
    RTLSDR_LFLAGS := $(shell pkg-config --libs-only-L librtlsdr)
    ifeq ($(RTLSDR_LFLAGS),-L)
      LIBS_SDR += $(shell pkg-config --libs-only-l --libs-only-other librtlsdr)
    else
      LIBS_SDR += $(shell pkg-config --libs librtlsdr)
    endif
  endif
endif

ifeq ($(BLADERF), yes)
  SDR_OBJ += sdr_bladerf.o
  DUMP1090_CPPFLAGS += -DENABLE_BLADERF
  DUMP1090_CFLAGS += $(shell pkg-config --cflags libbladeRF)
  LIBS_SDR += $(shell pkg-config --libs libbladeRF)
endif

ifeq ($(HACKRF), yes)
  SDR_OBJ += sdr_hackrf.o
  DUMP1090_CPPFLAGS += -DENABLE_HACKRF
  DUMP1090_CFLAGS += $(shell pkg-config --cflags libhackrf)
  LIBS_SDR += $(shell pkg-config --libs libhackrf)
endif

ifeq ($(LIMESDR), yes)
  SDR_OBJ += sdr_limesdr.o
  DUMP1090_CPPFLAGS += -DENABLE_LIMESDR
  DUMP1090_CFLAGS += $(shell pkg-config --cflags LimeSuite)
  LIBS_SDR += $(shell pkg-config --libs LimeSuite)
endif

ifeq ($(SOAPYSDR), yes)
  SDR_OBJ += sdr_soapy.o
  DUMP1090_CPPFLAGS += -DENABLE_SOAPYSDR
  DUMP1090_CFLAGS += $(shell pkg-config --cflags SoapySDR)
  LIBS_SDR += $(shell pkg-config --libs SoapySDR)
endif


##
## starch (runtime DSP code selection) mix, architecture-specific
##

ifneq ($(CPUFEATURES),yes)
  # need to be able to detect CPU features at runtime to enable any non-standard compiler flags
  STARCH_MIX := generic
  DUMP1090_CPPFLAGS += -DSTARCH_MIX_GENERIC
else
  ifeq ($(ARCH),x86_64)
    # AVX, AVX2
    STARCH_MIX := x86
    DUMP1090_CPPFLAGS += -DSTARCH_MIX_X86
  else ifeq ($(ARCH),amd64)
    # this is the Debian naming of x86_64
    STARCH_MIX := x86
    DUMP1090_CPPFLAGS += -DSTARCH_MIX_X86
  else ifeq ($(findstring aarch,$(ARCH)),aarch)
    STARCH_MIX := aarch64
    DUMP1090_CPPFLAGS += -DSTARCH_MIX_AARCH64
  else ifeq ($(findstring arm64,$(ARCH)),arm64)
    # Apple calls this arm64, not aarch64
    STARCH_MIX := aarch64
    DUMP1090_CPPFLAGS += -DSTARCH_MIX_AARCH64
  else ifeq ($(findstring arm,$(ARCH)),arm)
    # ARMv7 NEON
    STARCH_MIX := arm
    DUMP1090_CPPFLAGS += -DSTARCH_MIX_ARM
  else
    STARCH_MIX := generic
    DUMP1090_CPPFLAGS += -DSTARCH_MIX_GENERIC
  endif
endif
all: showconfig dump1090 view1090 starch-benchmark

ALL_CCFLAGS := $(CPPFLAGS) $(DUMP1090_CPPFLAGS) $(CFLAGS) $(DUMP1090_CFLAGS)

STARCH_COMPILE := $(CC) $(ALL_CCFLAGS) -c
include dsp/generated/makefile.$(STARCH_MIX)

showconfig:
	@echo "Building with:" >&2
	@echo "  Version string:   $(DUMP1090_VERSION)" >&2
	@echo "  Architecture:     $(ARCH)" >&2
	@echo "  DSP mix:          $(STARCH_MIX)" >&2
	@echo "  RTLSDR support:   $(RTLSDR)" >&2
	@echo "  BladeRF support:  $(BLADERF)" >&2
	@echo "  HackRF support:   $(HACKRF)" >&2
	@echo "  LimeSDR support:  $(LIMESDR)" >&2
	@echo "  SoapySDR support: $(SOAPYSDR)" >&2

%.o: %.c *.h
	$(CC) $(ALL_CCFLAGS) -c $< -o $@

dump1090: dump1090.o anet.o interactive.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o demod_2400.o stats.o cpr.o icao_filter.o track.o util.o convert.o ais_charset.o adaptive.o $(SDR_OBJ) $(COMPAT) $(CPUFEATURES_OBJS) $(STARCH_OBJS)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS) $(LIBS_SDR) $(LIBS_CURSES)

view1090: view1090.o anet.o interactive.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o ais_charset.o sdr_stub.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS) $(LIBS_CURSES)

faup1090: faup1090.o anet.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o ais_charset.o sdr_stub.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS)

starch-benchmark: cpu.o dsp/helpers/tables.o $(CPUFEATURES_OBJS) $(STARCH_OBJS) $(STARCH_BENCHMARK_OBJ)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS)

clean:
	rm -f *.o oneoff/*.o compat/clock_gettime/*.o compat/clock_nanosleep/*.o cpu_features/src/*.o dsp/generated/*.o dsp/helpers/*.o $(CPUFEATURES_OBJS) dump1090 view1090 faup1090 cprtests crctests oneoff/convert_benchmark oneoff/decode_comm_b oneoff/dsp_error_measurement oneoff/uc8_capture_stats starch-benchmark

test: cprtests
	./cprtests

cprtests: cpr.o cprtests.o
	$(CC) $(ALL_CCFLAGS) -g -o $@ $^ -lm

crctests: crc.c crc.h
	$(CC) $(ALL_CCFLAGS) -g -DCRCDEBUG -o $@ $<

benchmarks: oneoff/convert_benchmark
	oneoff/convert_benchmark

oneoff/convert_benchmark: oneoff/convert_benchmark.o convert.o util.o dsp/helpers/tables.o cpu.o $(CPUFEATURES_OBJS) $(STARCH_OBJS)
	$(CC) $(ALL_CCFLAGS) -g -o $@ $^ -lm -lpthread

oneoff/decode_comm_b: oneoff/decode_comm_b.o comm_b.o ais_charset.o
	$(CC) $(ALL_CCFLAGS) -g -o $@ $^ -lm

oneoff/dsp_error_measurement: oneoff/dsp_error_measurement.o dsp/helpers/tables.o cpu.o $(CPUFEATURES_OBJS) $(STARCH_OBJS)
	$(CC) $(ALL_CCFLAGS) -g -o $@ $^ -lm

oneoff/uc8_capture_stats: oneoff/uc8_capture_stats.o
	$(CC) $(ALL_CCFLAGS) -g -o $@ $^ -lm

starchgen:
	dsp/starchgen.py .

.PHONY: wisdom.local
wisdom.local: starch-benchmark
	./starch-benchmark -i 5 -o wisdom.local mean_power_u16 mean_power_u16_aligned magnitude_uc8 magnitude_uc8_aligned
	./starch-benchmark -i 5 -r wisdom.local -o wisdom.local

=== starch/Makefile ===
all: mypy

mypy:
	MYPYPATH=$(CURDIR)/stubs mypy --show-error-codes starch.py

=== starch/example/Makefile ===
CC ?= gcc
CFLAGS = -O3 -Wall -g

STARCH_COMPILE := $(CC) $(CFLAGS) -c

ARCH := $(shell uname -m)

all: generate starch-benchmark

ifneq (,$(findstring arm,$(ARCH)))
  -include generated/makefile.arm
else ifneq (,$(findstring x86_64,$(ARCH)))
  -include generated/makefile.x86_64
else
  -include generated/makefile.generic
endif

support.o: support.c
	$(CC) $(CFLAGS) -c -o $@ $^

starch-benchmark: $(STARCH_OBJS) $(STARCH_BENCHMARK_OBJ) support.o
	$(CC) $(CFLAGS) -o $@ $^

generate:
	./starchgen.py

clean:
	rm -f $(STARCH_OBJS) $(STARCH_BENCHMARK_OBJ) support.o starch-benchmark

=== debian/changelog ===
dump1090-fa (10.2) stable; urgency=medium

  * No change release for 10.2

 -- Nicholas Wan <nicholas.wan@flightaware.com>  Wed, 28 May 2025 12:48:45 -0500

dump1090-fa (10.1) stable; urgency=medium

  * SkyAware: Update aircraft DB to 2025-05-14
  * SkyAware: Update file name versioning to enable cache busting

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 14 May 2025 21:58:00 -0600

dump1090-fa (10.0.1) stable; urgency=medium

  * No change release for 10.0.1

 -- Nicholas Wan <nicholas.wan@flightaware.com>  Mon, 24 Mar 2025 10:56:18 -0500

dump1090-fa (10.0) stable; urgency=medium

  * Pass options to all SDR drivers for handling
  * soapysdr: --enable-agc doesn't take an option value, don't require one
  * Change calloc parameter order to fix build issues with newer gcc (courtesy @Swiftyhu, PR #239)
  * Add missing build package to README (courtesy @lstolcman, #234)
  * SkyAware: Replaces broken ChartBundle IFR and VFR layers with argGIS maps
  * SkyAware: Mobile display improvements (courtesy @gregdev, PR #235)

 -- Nicholas Wan <nicholas.wan@flightaware.com>  Wed, 26 Feb 2025 16:16:10 +0000

dump1090-fa (9.1~dev) UNRELEASED; urgency=medium

  * in development

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Fri, 10 Nov 2023 18:04:49 +0800

dump1090-fa (9.0) stable; urgency=medium

  * dump1090: SoapySDR support (courtesy @bkoehm, PR #209)
  * dump1090: fix handling of negative FMS altitudes in DO-260A messages
  * dump1090: update aircraft DB to 2023-10-26
  * packaging: add bookworm, arm64 support
  * packaging: discontinue stretch support
  * tools: update tools/csv-to-json.py for Python 3

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Mon, 06 Nov 2023 21:34:26 +0800

dump1090-fa (8.2) stable; urgency=medium

  * No change release for 8.1

 -- Eric Tran <eric.tran@flightaware.com>  Tue, 13 Dec 2022 20:06:00 -0600

dump1090-fa (8.1) stable; urgency=medium

  * No change release for 8.1

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 07 Dec 2022 19:26:00 -0600

dump1090-fa (8.0) stable; urgency=medium

  * dump1090: fix dropped samples stats accounting (#178 / #184)
  * dump1090: help text updates (#199, #145)
  * dump1090: warn about unimplemented --no-crc-check option if given (#201)
  * dump1090: implement 'l'/'L' Beast option to request local-only data (#204)
  * dump1090: emit receiver gain setting even when adaptive gain is off (#203)
  * dump1090: correctly handle gain stats on SDRs that don't implement the gain interface (#206)
  * SkyAware: remove a stray query string
  * SkyAware: improve visibility of range rings and altitude chart on the darker map layers
  * SkyAware: add colors to heywhatsthat.com rings (#148)
  * SkyAware: add favicon.ico (#101)
  * SkyAware: update Swiss flag (#175)
  * SkyAware: update aircraft DB to 2022-09-28

 -- Eric Tran <eric.tran@flightaware.com>  Tue, 06 Dec 2022 12:48:29 -0600

dump1090-fa (7.2) stable; urgency=medium

  * dump1090: Fix Makefile syntax error for Darwin OS build (courtesy @CodyCodeman, PR #170)
  * dump1090: set _POSIX_C_SOURCE to fix build failure with uclibc-ng (courtesy @ffontaine, PR #169)
  * SkyAware: Remove obselete map interface at /dump1090-fa
  * SkyAware: Remove OSM Black & White layer which is no longer in service

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 09 Mar 2022 20:09:55 -0600

dump1090-fa (7.1) stable; urgency=medium

  * Preserve start/upgrade postinst logic for pre 7.1 updates until we support compat 10 behavior

 -- Eric Tran <eric.tran@flightaware.com>  Wed, 12 Jan 2022 11:37:20 -0600

dump1090-fa (7.0) stable; urgency=medium

  * dump1090: Allow env vars (not only command line overrdies) to set CPU_FEATURES_{ARCH,UNAME}
  * dump1090: Treat ARCH=arm64 like ARCH=aarch64
  * dump1090: Try to respect CFLAGS/CPPFLAGS as far as possible; move required extra flags into a separate var
  * dump1090: Adaptive gain - more aggressively re-probe for higher gain after a decrease in gain due to increased noise floor
  * dump1090: Cleanup AVR parsing
  * SkyAware: Update aircraft db to 20211210
  * SkyAware: Cleanup unused Openlayers files

 -- Eric Tran <eric.tran@flightaware.com>  Mon, 20 Dec 2021 11:00:00 -0600

dump1090-fa (6.1) stable; urgency=medium

  * No-change 6.1 release for PiAware 6.1

 -- Oliver Jowett <oliver.jowett@flightaware.com>  Mon, 06 Sep 2021 16:06:00 +0800

dump1090-fa (6.0) stable; urgency=medium

  * dump1090: Adaptive gain feature with associated dump1090-fa config parameters
  * dump1090: Add support for decoding BDS 4,4 - Meteorological Routine Air Report (MRAR) Comm-B messages
  * dump1090: Stratux output: include current receiver gain (courtesy @b3nn0, PR #144)
  * dump1090: Enable rtlsdr bounce buffers on aarch64 (courtesy @wiedehopf for suggestion)
  * dump1090: New default dump1090-fa config file format
  * dump1090: Use compat/compat.h for endian-swapping functions in DSP code
  * dump1090: Report json write errors, with some rate limiting (fixes issue #129)
  * starch: Update starch to upstream commit 0c8249fa4bc523345c156885542e9192e8bf68fd
  * SkyAware: restrict overlay rendering to covered areas (reduce source load) (courtesy @wiedehopf, PR #137)
  * SkyAware: Fix ignored DisplayUnits in config.js (courtesy @paulyc, PR #76)
  * SkyAware: Update aircraft db to 20210817 with better Australian aircraft & types

 -- Eric Tran <eric.tran@flightaware.com>  Tue, 31 Aug 2021 12:41:06 -0600

dump1090-fa (5.0) stable; urgency=medium

  * SkyAware: New Altitude, Speed, Aircraft Ident, and Aircraft Type filters to fine tune the select aircraft you want see
  * SkyAware: Ability to toggle visibility of ADS-B, MLAT, UAT, TIS-B, and Other aircraft on SkyAware using the check boxes under the aircraft table
  * SkyAware: Ability to show Aircraft Ident labels for all aircraft on your display (found in the View Toggles list in the settings menu)
  * SkyAware: A merged SkyAware map of 1090 and UAT aircraft for those with dual 1090/978 setups.


=== debian/control ===
Source: dump1090-fa
Section: embedded
Priority: extra
Maintainer: Oliver Jowett <oliver.jowett@flightaware.com>
Build-Depends: debhelper(>=12),
  librtlsdr-dev <!custom> <rtlsdr>,
  libbladerf-dev <!custom> <bladerf>,
  libhackrf-dev <!custom> <hackrf>,
  liblimesuite-dev <!custom> <limesdr>,
  libsoapysdr-dev <!custom> <soapysdr>,
  libusb-1.0-0-dev <!custom> <rtlsdr> <bladerf> <hackrf> <limesdr>,
  pkg-config, libncurses5-dev
Standards-Version: 3.9.3
Homepage: http://www.flightaware.com/
Vcs-Git: https://github.com/flightaware/dump1090.git

Package: dump1090-fa
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lighttpd
Description: FlightAware ADS-B Ground Station System for SDRs
 Networked Aviation Mode S / ADS-B decoder/translator with support
 for RTL-SDR, BladeRF, HackRF, and LimeSDR software defined radio USB
 device support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

ifeq (,$(filter custom,$(DEB_BUILD_PROFILES)))
  # Standard build
  RTLSDR = yes
  BLADERF = yes
  HACKRF = yes
  LIMESDR = yes
  SOAPYSDR = yes
else
  # Custom build
  ifneq (,$(filter rtlsdr,$(DEB_BUILD_PROFILES)))
    RTLSDR = yes
  else
    RTLSDR = no
  endif
  ifneq (,$(filter bladerf,$(DEB_BUILD_PROFILES)))
    BLADERF = yes
  else
    BLADERF = no
  endif
  ifneq (,$(filter hackrf,$(DEB_BUILD_PROFILES)))
    HACKRF = yes
  else
    HACKRF = no
  endif
  ifneq (,$(filter limesdr,$(DEB_BUILD_PROFILES)))
    LIMESDR = yes
  else
    LIMESDR = no
  endif
  ifneq (,$(filter soapysdr,$(DEB_BUILD_PROFILES)))
    SOAPYSDR = yes
  else
    SOAPYSDR = no
  endif
endif

override_dh_auto_build:
	dh_auto_build -- ARCH=$(DEB_HOST_ARCH) RTLSDR=$(RTLSDR) BLADERF=$(BLADERF) HACKRF=$(HACKRF) LIMESDR=$(LIMESDR) SOAPYSDR=$(SOAPYSDR) DUMP1090_VERSION=$(DEB_VERSION)

override_dh_install:
	dh_install
	install -d debian/dump1090-fa/usr/bin
	cp -a dump1090 debian/dump1090-fa/usr/bin/dump1090-fa
	cp -a view1090 debian/dump1090-fa/usr/bin/view1090-fa

override_dh_installinit:
	dh_installinit --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd --no-restart-after-upgrade

%:
	dh $@
